import { AwsSdkSigV4AuthInputConfig, AwsSdkSigV4AuthResolvedConfig, AwsSdkSigV4PreviouslyResolved } from "@aws-sdk/core";
import { HandlerExecutionContext, HttpAuthScheme, HttpAuthSchemeParameters, HttpAuthSchemeParametersProvider, HttpAuthSchemeProvider } from "@smithy/types";
import { ApiGatewayManagementApiClientResolvedConfig } from "../ApiGatewayManagementApiClient";
/**
 * @internal
 */
export interface ApiGatewayManagementApiHttpAuthSchemeParameters extends HttpAuthSchemeParameters {
    region?: string;
}
/**
 * @internal
 */
export interface ApiGatewayManagementApiHttpAuthSchemeParametersProvider extends HttpAuthSchemeParametersProvider<ApiGatewayManagementApiClientResolvedConfig, HandlerExecutionContext, ApiGatewayManagementApiHttpAuthSchemeParameters, object> {
}
/**
 * @internal
 */
export declare const defaultApiGatewayManagementApiHttpAuthSchemeParametersProvider: (config: ApiGatewayManagementApiClientResolvedConfig, context: HandlerExecutionContext, input: object) => Promise<ApiGatewayManagementApiHttpAuthSchemeParameters>;
/**
 * @internal
 */
export interface ApiGatewayManagementApiHttpAuthSchemeProvider extends HttpAuthSchemeProvider<ApiGatewayManagementApiHttpAuthSchemeParameters> {
}
/**
 * @internal
 */
export declare const defaultApiGatewayManagementApiHttpAuthSchemeProvider: ApiGatewayManagementApiHttpAuthSchemeProvider;
/**
 * @internal
 */
export interface HttpAuthSchemeInputConfig extends AwsSdkSigV4AuthInputConfig {
    /**
     * Configuration of HttpAuthSchemes for a client which provides default identity providers and signers per auth scheme.
     * @internal
     */
    httpAuthSchemes?: HttpAuthScheme[];
    /**
     * Configuration of an HttpAuthSchemeProvider for a client which resolves which HttpAuthScheme to use.
     * @internal
     */
    httpAuthSchemeProvider?: ApiGatewayManagementApiHttpAuthSchemeProvider;
}
/**
 * @internal
 */
export interface HttpAuthSchemeResolvedConfig extends AwsSdkSigV4AuthResolvedConfig {
    /**
     * Configuration of HttpAuthSchemes for a client which provides default identity providers and signers per auth scheme.
     * @internal
     */
    readonly httpAuthSchemes: HttpAuthScheme[];
    /**
     * Configuration of an HttpAuthSchemeProvider for a client which resolves which HttpAuthScheme to use.
     * @internal
     */
    readonly httpAuthSchemeProvider: ApiGatewayManagementApiHttpAuthSchemeProvider;
}
/**
 * @internal
 */
export declare const resolveHttpAuthSchemeConfig: <T>(config: T & HttpAuthSchemeInputConfig & AwsSdkSigV4PreviouslyResolved) => T & HttpAuthSchemeResolvedConfig;
